﻿Public Class Form1
    Dim imgMinimizeBtn As Image 'Image 개체 생성
    Dim strCurImgPath As String '이미지 경로

    Dim ptMouseCurrentPos As Point  '마우스 클릭 좌표 지정
    Dim ptMouseNewPos As Point  '이동시 마우스 좌표
    Dim ptFormCurrentPos As Point  '폼 위치 좌표 지정
    Dim ptFormNewPos As Point  '이동시 폼 위치 좌표
    Dim bFormMouseDown As Boolean = False

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.picMinimize.Image = Image.FromFile("..\..\img\Minimize_Normal.jpg")
        Me.picClose.Image = Image.FromFile("..\..\img\Close_Normal.jpg")
    End Sub

    Private Sub Form1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        If e.Button = MouseButtons.Left Then
            bFormMouseDown = True '왼쪽 마우스 클릭 체크
            ptMouseCurrentPos = Control.MousePosition '마우스 클릭 좌표
            ptFormCurrentPos = Me.Location '폼의 위치 좌표
        End If
    End Sub

    Private Sub Form1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        If e.Button = MouseButtons.Left Then
            bFormMouseDown = False '왼쪽 마우스 클릭 해체 체크
        End If
    End Sub

    Private Sub Form1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        If bFormMouseDown = True Then '왼쪽 마우스 클릭시
            ptMouseNewPos = Control.MousePosition
            ptFormNewPos.X = ptMouseNewPos.X - ptMouseCurrentPos.X + ptFormCurrentPos.X '마우스 이동시 가로 좌표
            ptFormNewPos.Y = ptMouseNewPos.Y - ptMouseCurrentPos.Y + ptFormCurrentPos.Y '마우스 이동시 세로 좌표
            Me.Location = ptFormNewPos
            ptFormCurrentPos = ptFormNewPos
            ptMouseCurrentPos = ptMouseNewPos
        End If
    End Sub

    Private Sub picMinimize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picMinimize.Click
        WindowState = FormWindowState.Minimized
    End Sub

    Private Sub picMinimize_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picMinimize.MouseDown
        Me.picMinimize.Image = Image.FromFile("..\..\img\Minimize_Down.jpg")
    End Sub

    Private Sub picMinimize_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picMinimize.MouseLeave
        Me.picMinimize.Image = Image.FromFile("..\..\img\Minimize_Normal.jpg")
    End Sub

    Private Sub picMinimize_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picMinimize.MouseMove
        Me.picMinimize.Image = Image.FromFile("..\..\img\Minimize_Over.jpg")
    End Sub

    Private Sub picClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picClose.Click
        Me.Close()
    End Sub

    Private Sub picClose_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picClose.MouseDown
        Me.picClose.Image = Image.FromFile("..\..\img\Close_Down.jpg")
    End Sub

    Private Sub picClose_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picClose.MouseLeave
        Me.picClose.Image = Image.FromFile("..\..\img\Close_Normal.jpg")
    End Sub

    Private Sub picClose_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picClose.MouseMove
        Me.picClose.Image = Image.FromFile("..\..\img\Close_Over.jpg")
    End Sub

    Private Sub 종료ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 종료ToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub 회ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 회ToolStripMenuItem.Click
        CheckOff()
        Me.BackColor = Color.Gray
        Me.회ToolStripMenuItem.Checked = True
    End Sub
    Private Sub CheckOff()
        Me.회ToolStripMenuItem.Checked = False
        Me.검정색ToolStripMenuItem.Checked = False
        Me.빨간색ToolStripMenuItem.Checked = False
    End Sub

    Private Sub 검정색ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 검정색ToolStripMenuItem.Click
        CheckOff()
        Me.BackColor = Color.Black
        Me.검정색ToolStripMenuItem.Checked = True
    End Sub

    Private Sub 빨간색ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 빨간색ToolStripMenuItem.Click
        CheckOff()
        Me.BackColor = Color.Red
        Me.빨간색ToolStripMenuItem.Checked = True
    End Sub
End Class
