﻿Imports System.IO

Public Class Form1
    Dim FileSrc = String.Empty '복사 및 이동 소스 파일의 경로
    Dim FileDest = String.Empty '복사 및 이동 목적지 파일의 경로

    Private Sub btnSrc_Click(sender As Object, e As EventArgs) Handles btnSrc.Click
        If Me.fbdFolder.ShowDialog = DialogResult.OK Then
            Me.lvSrc.Items.Clear()
            Me.txtSrc.Text = Me.fbdFolder.SelectedPath
            FileSrc = Me.fbdFolder.SelectedPath

            Dim di As DirectoryInfo = New DirectoryInfo(Me.txtSrc.Text)
            For Each fs As FileInfo In di.GetFiles()
                Me.lvSrc.Items.Add(New ListViewItem(New String() {fs.Name}))
            Next
        End If
    End Sub

    Private Sub btnDest_Click(sender As Object, e As EventArgs) Handles btnDest.Click
        If Me.fbdFolder.ShowDialog() = DialogResult.OK Then
            Me.lvDest.Items.Clear()
            Me.txtDest.Text = Me.fbdFolder.SelectedPath
            FileDest = Me.fbdFolder.SelectedPath
            Dim di As DirectoryInfo = New DirectoryInfo(FileDest)
            For Each fs As FileInfo In di.GetFiles()
                Me.lvDest.Items.Add(New ListViewItem(New String() {fs.Name}))
            Next
        End If
    End Sub

    Private Sub btnRun_Click(sender As Object, e As EventArgs) Handles btnRun.Click
        If Me.txtDest.Text = Me.txtSrc.Text Then
            MessageBox.Show("경로가 같을 수 없습니다.", "에러", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        Dim i As Integer = 0
        Dim sum As Integer = Me.lvSrc.SelectedItems.Count

        For Each items As ListViewItem In Me.lvSrc.SelectedItems
            i += 1
            If File.Exists(FileSrc & "\" & items.Text) = False Then
                MessageBox.Show("존재하지 않는 파일입니다.", "에러", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Continue For
            End If
            Dim fi As FileInfo = New FileInfo(FileSrc & "\" & items.Text)
            Dim frm2 As Form2 = New Form2()
            frm2.FileSrc = FileSrc & "\" & items.Text
            frm2.FileDest = FileDest & "\" & items.Text
            frm2.FileName = items.Text
            If (frm2.ShowDialog() = DialogResult.OK) Then
                frm2.Close()
                Dim item As ListViewItem = Me.lvDest.FindItemWithText(items.Text)
                If item Is Nothing Then
                    Me.lvDest.Items.Add(New ListViewItem(New String() {items.Text}))
                End If
                If rbMove.Checked Then
                    fi.Delete()
                    Me.lvSrc.Items.RemoveAt(items.Text)
                End If
            End If
            Dim v As Integer = CInt(i * 100 / sum)
            Me.tspgrbar.Value = v
            Me.tsslblStatus.Text = " " + v.ToString() + " %"
        Next
    End Sub
End Class
