﻿Imports System.IO

Public Class Form1
    Private Sub btnRPath_Click(sender As Object, e As EventArgs) Handles btnRPath.Click
        If Me.ofdFile.ShowDialog() = DialogResult.OK Then
            Me.txtRPath.Text = Me.ofdFile.FileName
        End If
    End Sub

    Private Function txtCheck() As Boolean
        If Me.txtRPath.Text = "" Then
            Return False
        Else
            Return True
        End If
    End Function

    Private Sub btnRARead_Click(sender As Object, e As EventArgs) Handles btnRARead.Click
        If txtCheck() = False Then
            Return
        End If
        If File.Exists(Me.txtRPath.Text) Then
            Using sr As StreamReader = New StreamReader(Me.txtRPath.Text, System.Text.Encoding.UTF8)
                Me.txtRView.Text = sr.ReadToEnd()
            End Using
        Else
            MessageBox.Show("읽을 파일이 없습니다.", "에러", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub btnRLRead_Click(sender As Object, e As EventArgs) Handles btnRLRead.Click
        If txtCheck() = False Then
            Return
        End If
        Me.txtRView.Clear()
        If File.Exists(Me.txtRPath.Text) Then
            Using sr As StreamReader = New StreamReader(Me.txtRPath.Text, System.Text.Encoding.UTF8)
                Dim line As String = String.Empty
                While True
                    line = sr.ReadLine()
                    If line Is Nothing Then
                        Exit While
                    End If
                    Me.txtRView.AppendText(line + Environment.NewLine)
                End While
            End Using
        Else
            MessageBox.Show("읽을 파일이 없습니다.", "에러", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub btnWPath_Click(sender As Object, e As EventArgs) Handles btnWPath.Click
        If Me.sfdFile.ShowDialog() = DialogResult.OK Then
            Me.txtWPath.Text = Me.sfdFile.FileName
        End If
    End Sub

    Private Sub btnWLSave_Click(sender As Object, e As EventArgs) Handles btnWLSave.Click
        If Me.txtWPath.Text = "" Then
            Return
        End If
        Using sw As StreamWriter = New StreamWriter(Me.txtWPath.Text)
            For Each Str As String In Me.txtWView.Lines
                sw.WriteLine(Str)
            Next
        End Using
        MessageBox.Show("파일이 정상적으로 저장되었습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub btnWASave_Click(sender As Object, e As EventArgs) Handles btnWASave.Click
        If Me.txtWPath.Text = "" Then
            Return
        End If
        Using sw As StreamWriter = New StreamWriter(Me.txtWPath.Text)
            sw.WriteLine(Me.txtWView.Text)
        End Using
        MessageBox.Show("파일이 정상적으로 저장되었습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub
End Class
