﻿Imports System.IO
Imports System.Windows.Forms

Public Class FileDelete
    Dim fi As FileInfo = Nothing
    Dim fs As FileStream = Nothing
    Dim byteArray As Byte() = Nothing
    Public Property FilePath As String
    Public Delegate Sub ProcessEventHandler(ByVal Current As Integer)
    Public Event runPer As ProcessEventHandler

    Public Sub British_HMG_IS5_BaseLine(ByVal FilePath As String)
        fi = New FileInfo(FilePath)
        Try
            byteArray = New Byte(fi.Length - 1) {}
            RaiseEvent runPer(0)
            Application.DoEvents()
            For i As Integer = 0 To fi.Length - 1
                byteArray(i) = &H0
                RaiseEvent runPer(CInt(CSng(i / CSng(fi.Length - 1.0)) * 100.0))
            Next
            RunBuffer(FilePath, byteArray)
            fi.Delete()
            Application.DoEvents()
        Catch ex As Exception
            MessageBox.Show(ex.ToString())
        End Try
    End Sub

    Public Sub British_HMG_IS5_Enhanced(ByVal FilePath As String)
        fi = New FileInfo(FilePath)
        Try
            byteArray = New Byte(fi.Length - 1) {}
            RaiseEvent runPer(0)
            Application.DoEvents()
            Dim n As Integer = 0
            For c As Integer = 1 To 3
                Select Case c
                    Case 1
                        For i As Integer = 0 To fi.Length - 1
                            byteArray(i) = &H0
                            RaiseEvent runPer(CInt(CSng(n / CSng((fi.Length - 1.0) * 3.0)) * 100.0))
                            n += 1
                        Next
                        RunBuffer(FilePath, byteArray)
                        byteArray = New Byte(fi.Length - 1) {}
                    Case 2
                        For i As Integer = 0 To fi.Length - 1
                            byteArray(i) = &H0
                            RaiseEvent runPer(CInt(CSng(n / CSng((fi.Length - 1.0) * 3.0)) * 100.0))
                            n += 1
                        Next
                        RunBuffer(FilePath, byteArray)
                        byteArray = New Byte(fi.Length - 1) {}
                    Case 3
                        Select Case RandomBuffer(n)
                            Case True
                        End Select
                        RunBuffer(FilePath, byteArray)
                        byteArray = New Byte(fi.Length - 1) {}
                End Select
            Next
            fi.Delete()
        Catch ex As Exception
            MessageBox.Show(ex.ToString())
        End Try
    End Sub

    Private Sub RunBuffer(ByVal FilePath As String, ByVal Buffer As Byte())
        fs = New FileStream(FilePath, FileMode.Open, FileAccess.Write, FileShare.None)
        fs.Write(Buffer, 0, Buffer.Length)
        fs.Flush()
        fs.Close()
    End Sub

    Private Function RandomBuffer(ByVal n As Integer) As Boolean
        byteArray = New Byte(fi.Length - 1) {}
        Application.DoEvents()
        For i As Integer = 0 To fi.Length - 1
            byteArray(i) = RandomByte()
            RaiseEvent runPer(CInt(CSng(n / CSng((fi.Length - 1.0) * 3.0)) * 100.0))
            n += 1
        Next
        Return True
    End Function

    Private Function RandomByte() As Byte
        Dim Minimo As Byte = 0
        Dim Maximo As Byte = 255
        Dim Rnd As Random = New Random()
        Dim ResultRnd As Byte = CByte(Rnd.Next(Minimo, Maximo))
        Return ResultRnd
    End Function
End Class
