﻿Public Class Form1
    Dim bmpFrmBg As Bitmap = New Bitmap(GetType(Form1), "bg.bmp")
    Dim bmpcloseUp As Bitmap = New Bitmap(GetType(Form1), "closeup.bmp")
    Dim bmpcloseDown As Bitmap = New Bitmap(GetType(Form1), "closedown.bmp")
    Dim bmpminUp As Bitmap = New Bitmap(GetType(Form1), "minup.bmp")
    Dim bmpminDown As Bitmap = New Bitmap(GetType(Form1), "mindown.bmp")

    Public Sub New()
        InitializeComponent()

        FlexibleForm.CreateControlRegion(Me, bmpFrmBg, True)
        FlexibleForm.CreateControlRegion(btnClose, bmpcloseUp, False)
        FlexibleForm.CreateControlRegion(btnMin, bmpminUp, False)
    End Sub

    Dim FormMouseDown As Boolean = False
    Dim ptMouseCurrentPos As Point '마우스 클릭 좌표 지정
    Dim ptMouseNewPos As Point  '이동시 마우스 좌표
    Dim ptFormCurrentPos As Point  '폼 위치 좌표 지정
    Dim ptFormNewPos As Point  '이동시 폼 위치 좌표

    Private Sub btnClose_Click(sender As Object, e As EventArgs) Handles btnClose.Click
        Application.ExitThread()
    End Sub

    Private Sub btnClose_MouseEnter(sender As Object, e As EventArgs) Handles btnClose.MouseEnter
        FlexibleForm.CreateControlRegion(btnClose, bmpcloseDown, False)
    End Sub

    Private Sub btnClose_MouseLeave(sender As Object, e As EventArgs) Handles btnClose.MouseLeave
        FlexibleForm.CreateControlRegion(btnClose, bmpcloseUp, False)
    End Sub

    Private Sub btnMin_Click(sender As Object, e As EventArgs) Handles btnMin.Click
        Me.WindowState = FormWindowState.Minimized
    End Sub

    Private Sub btnMin_MouseEnter(sender As Object, e As EventArgs) Handles btnMin.MouseEnter
        FlexibleForm.CreateControlRegion(btnMin, bmpminDown, False)
    End Sub

    Private Sub btnMin_MouseLeave(sender As Object, e As EventArgs) Handles btnMin.MouseLeave
        FlexibleForm.CreateControlRegion(btnMin, bmpminUp, False)
    End Sub

    Private Sub Form1_MouseMove(sender As Object, e As MouseEventArgs) Handles MyBase.MouseMove
        If FormMouseDown = True Then
            ptMouseNewPos = Control.MousePosition
            ptFormNewPos.X = ptMouseNewPos.X - ptMouseCurrentPos.X + ptFormCurrentPos.X '마우스 이동시 가로 좌표
            ptFormNewPos.Y = ptMouseNewPos.Y - ptMouseCurrentPos.Y + ptFormCurrentPos.Y '마우스 이동시 세로 좌표
            Me.Location = ptFormNewPos
            ptFormCurrentPos = ptFormNewPos
            ptMouseCurrentPos = ptMouseNewPos
        End If
    End Sub

    Private Sub Form1_MouseUp(sender As Object, e As MouseEventArgs) Handles MyBase.MouseUp
        If e.Button = MouseButtons.Left Then
            FormMouseDown = False '왼쪽 마우스 클릭 해제
        End If
    End Sub

    Private Sub Form1_MouseDown(sender As Object, e As MouseEventArgs) Handles MyBase.MouseDown
        If e.Button = MouseButtons.Left Then
            FormMouseDown = True '왼쪽 마우스 클릭 체크
            ptMouseCurrentPos = Control.MousePosition '마우스 클릭 좌표
            ptFormCurrentPos = Me.Location
        End If
    End Sub
End Class
