﻿Imports System.Drawing.Imaging

Public Class Form1
    Dim orgLocalPoint As Point '폼 위치
    Dim orgLocalSize As Size '폼 사이즈
    Dim orgbool As Boolean = True '폼의 위치 및 사이즈 설정 여부
    Dim capbool As Boolean = False '화면 캡처 여부
    Dim ScreenG As Graphics '캡처 스크린을 위한 그래픽 클래스 개체
    Dim player As New System.Media.SoundPlayer 'wav 파일 실행
    Dim CaptWin As Bitmap '캡처를 위한 비트맵 개체
    Private Sub Form1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = "c" Then
            orgbool = False
            capbool = True
            Me.Opacity = 0.0
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.None
            Me.Location = New Point(0, 0)
            Me.Size = New Size(Screen.PrimaryScreen.Bounds.Size)
            Dim fullScreen = Screen.PrimaryScreen.Bounds
            CaptWin = New Bitmap(fullScreen.Width, fullScreen.Height)
            ScreenG = Graphics.FromImage(CaptWin)
            ScreenG.CopyFromScreen(PointToScreen(New Point(0, 0)), New Point(0, 0), fullScreen.Size)
            Me.picbScreen.Image = CaptWin
            player.SoundLocation = "../../wav/capture.wav"
            player.Play()
            Me.Opacity = 100.0
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.FixedSingle
            Me.Location = orgLocalPoint
            Me.Size = orgLocalSize
            orgbool = True
        ElseIf e.KeyChar = "e" Then
            player.SoundLocation = "../../wav/ereser.wav"
            player.Play()
            capbool = False
            Me.picbScreen.Image = Nothing
        ElseIf e.KeyChar = "s" Then
            If capbool = True Then
                Using SFile As New SaveFileDialog
                    SFile.OverwritePrompt = True
                    SFile.FileName = "화면캡쳐"
                    SFile.Filter = "이미지 파일(*.jpg)|*.jpg"
                    Dim Rst As DialogResult = SFile.ShowDialog()
                    If Rst = DialogResult.OK Then
                        CaptWin.Save(SFile.FileName, ImageFormat.Jpeg)
                    End If
                End Using
            Else
                MessageBox.Show("캡쳐한 화면이 없습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        End If
    End Sub

    Private Sub Form1_LocationChanged(sender As Object, e As EventArgs) Handles MyBase.LocationChanged
        If orgbool = True Then
            orgLocalPoint = Me.Location
            orgLocalSize = Me.Size
        End If
    End Sub
End Class
