﻿
Public Class Form1

    Dim ImageFile As Bitmap = Nothing '비트맴 이미지 리소스 저장
    Dim fnset As Boolean = Nothing '글꼴
    Dim fncol As Boolean = Nothing '글 색상

    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        If Me.ofdFile.ShowDialog() = DialogResult.OK Then
            Me.txtBack.Text = Me.ofdFile.FileName
        End If
    End Sub

    Private Sub btnView_Click(sender As Object, e As EventArgs) Handles btnView.Click
        If txtCheck() Then
            Mark.BackImgPath = Me.txtBack.Text
            Mark.MarkImgText = Me.txtMark.Text
            Mark.MarkOpacity = Me.hsbOpacity.Value
            Me.picbView.Image = Mark.NewImage().Image
        End If
    End Sub

    Private Function txtCheck() As Boolean
        Dim Flag As Boolean = True
        If Me.txtBack.Text = "" Then
            MessageBox.Show("배경 이미지 파일을 선택하지 않았습니다.",
                    "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Flag = False
        End If
        If Me.txtMark.Text = "" Then
            MessageBox.Show("마킹 이미지 파일을 선택하지 않았습니다.",
                    "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Flag = False
        End If
        If fnset = False Then
            MessageBox.Show("마킹 글꼴을 선택하지 않았습니다.",
                    "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Flag = False
        End If
        If fncol = False Then
            MessageBox.Show("마킹 색상을 선택하지 않았습니다.",
                    "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Flag = False
        End If
        Return Flag
    End Function

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        If Me.picbView.Image IsNot Nothing Then
            If Me.sfdImage.ShowDialog() = DialogResult.OK Then
                ImageFile = New Bitmap(Mark.ImageSize.Width, Mark.ImageSize.Height)
                ImageFile = Me.picbView.Image
                Me.ImageFile.Save(sfdImage.FileName, System.Drawing.Imaging.ImageFormat.Jpeg)
            End If
        End If
    End Sub

    Private Sub 글꼴ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 글꼴ToolStripMenuItem.Click
        If Me.fdlg.ShowDialog() = DialogResult.OK Then
            Mark.fnset = Me.fdlg.Font
            fnset = True
        End If
    End Sub

    Private Sub 색상ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 색상ToolStripMenuItem.Click
        If Me.cdlg.ShowDialog() = DialogResult.OK Then
            Mark.fnCol = Me.cdlg.Color
            fncol = True
        End If
    End Sub
End Class
