﻿Imports System.Drawing.Imaging
Imports System.Windows.Forms

Public Class Mark
    Public Shared BackImgPath As String = ""
    Public Shared MarkImgText As String = ""
    Public Shared MarkOpacity As Single = 50
    Public Shared ImageSize As Image = Nothing
    Public Shared fnset As Font = Nothing
    Public Shared fnCol As Color = Nothing

    Public Shared Function NewImage() As PictureBox

        Dim orgImg As Image = Image.FromFile(BackImgPath)
        ImageSize = orgImg
        Dim tmpImg As New Bitmap(orgImg.Width, orgImg.Height)
        Dim markImg As Bitmap = New Bitmap(100, 100)
        markImg.SetResolution(100, 100)
        Dim g As Graphics = Graphics.FromImage(markImg)
        g.PageUnit = GraphicsUnit.Point
        g.Clear(Color.Empty)
        Dim fn As Font = fnset
        Dim drawBrush As SolidBrush = New SolidBrush(fnCol)
        g.DrawString(markImgText, fn, drawBrush, New RectangleF(0, 0, 100, 100), StringFormat.GenericDefault)
        Dim setOpacity As Single = MarkOpacity / 100

        Dim newGrp As Graphics = Graphics.FromImage(tmpImg)

        Dim SetColorMatrix As Single()() = {
           New Single() {1, 0, 0, 0, 0},
           New Single() {0, 1, 0, 0, 0},
           New Single() {0, 0, 1, 0, 0},
           New Single() {0, 0, 0, setOpacity, 0},
           New Single() {0, 0, 0, 0, 1}}

        Dim clrMatrix As New ColorMatrix(SetColorMatrix)
        Dim setImage As New ImageAttributes()
        setImage.SetColorMatrix(clrMatrix, ColorMatrixFlag.Default, ColorAdjustType.Bitmap)

        newGrp.DrawImage(orgImg, 0, 0, orgImg.Width, orgImg.Height)

        Dim orw As Single = CSng(orgImg.Width * 0.3)
        Dim orh As Single = CSng(orgImg.Height * 0.4)
        Dim mix As Single = CSng((orgImg.Width / 2) + (orw / 2))
        Dim miy As Single = CSng((orgImg.Height / 2) + (orh / 2) + ((orh / 2) / 2))
        Dim msw As Single = markImg.Width
        Dim msh As Single = markImg.Height

        newGrp.DrawImage(markImg, New Rectangle(CInt(mix), CInt(miy), CInt(orw), CInt(orh)),
                             0.0F, 0.0F, msw, msh,
                             GraphicsUnit.Pixel, setImage)

        Dim NewMarkImage As PictureBox = New PictureBox()
        NewMarkImage.Image = tmpImg
        Return NewMarkImage
    End Function
End Class
