﻿Imports System.IO

Public Class Form1
    Dim kind As String = String.Empty '한글 또는 영어
    Dim array = 0 '랜덤 수 지정
    Dim jumsu = 0 '점수
    Dim selectlbl '1~6 랜덤 수(랜덤벽돌 지정)
    Dim maxjumsu = 0 '최종점수
    Dim word As String() '배열에 워드 지정
    Dim TempKorword As String() = New String() {"가나다", "라마바", "아자차", "카파하", "도레미", "파솔라"} '배열에 워드 지정
    Dim TempEnword As String() = New String() {"abc", "def", "ghi", "jkl", "mno", "pqr"} '배열에 워드 지정

    Private Sub 환경설정ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 환경설정ToolStripMenuItem.Click
        If Form2.ShowDialog() = DialogResult.OK Then
            Me.lblGrade.Text = Form2.ReturnStep
            kind = Form2.ReturnKind
        End If
    End Sub

    Private Sub 사용자설정ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 사용자설정ToolStripMenuItem.Click
        If Form3.ShowDialog() = DialogResult.OK Then
            Me.lblName.Text = Form3.ReturnName '사용자 이름 설정
            If Form3.checkNum = 1 Then
                Me.lblImg.ImageIndex = 0 '이미지 설정(남자)
            Else
                Me.lblImg.ImageIndex = 1 '이미지 설정(여자)
            End If
            Me.lblImg.Text = ""
            Me.btnStart.Enabled = True '[시작] 버튼 활성화 
            Me.btnStop.Enabled = True '[정지] 버튼 활성화
        End If
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        Dim Rekind = 0
        If File.Exists("setup.txt") = False Then
            MessageBox.Show("단어가 없어 기본 게임으로 시작합니다.", "알림", MessageBoxButtons.OK,
                            MessageBoxIcon.Information)
            If kind = "한글" Then word = TempKorword Else word = TempEnword
            array = word.Length
        Else
            If kind = "한글" Then Rekind = 1 Else If kind = "영어" Then Rekind = 2 Else Rekind = 1

            Dim sr = File.OpenText("setup.txt")
            While True
                Dim str = sr.ReadLine()
                If str Is Nothing Then Exit While
                If str.Split("&")(0) = Convert.ToString(Rekind) Then array += 1
            End While
            word = New String(array) {}
            sr.Close()

            If array < 5 Then
                MessageBox.Show("단어가 적절하지 않아 기본 게임으로 시작합니다.", "알림", MessageBoxButtons.OK,
                MessageBoxIcon.Information)
                If kind = "한글" Then word = TempKorword Else word = TempEnword
                array = word.Length
            Else
                Dim srt = File.OpenText("setup.txt")
                Dim k = 0
                While True
                    Dim str = srt.ReadLine()
                    If str Is Nothing Then Exit While
                    If str.Split("&")(0) = Convert.ToString(Rekind) Then word(k) = str.Split("&")(1) : k += 1
                End While
                srt.Close()
            End If
        End If

        Me.lblLife.Width = 200
        Me.txtJumsu.Text = "0"

        MessageBox.Show("제 " + lblGrade.Text + "단계입니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.None)
        Me.txtInsert.Focus()

        If randomtim.Enabled = False Then
            randomtim.Enabled = True
            Dim r = New Random()
            Dim i = r.Next(0, array - 4)
            Me.button1.Text = word(i)
            Me.button2.Text = word(i + 1)
            Me.button3.Text = word(i + 2)
            Me.button4.Text = word(i + 3)
            Me.button5.Text = word(i + 4)
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        e.Cancel = True
        Dim dlr = MessageBox.Show("게임을 완전히 종료합니다.", "끝내기", MessageBoxButtons.YesNo, MessageBoxIcon.None)
        Select Case dlr
            Case DialogResult.Yes
                Application.ExitThread() '폼 종료
            Case DialogResult.No
        End Select
    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        Me.randomtim.Enabled = False
        Me.btn1tim.Enabled = False
        Me.btn2tim.Enabled = False
        Me.btn3tim.Enabled = False
        Me.btn4tim.Enabled = False
        Me.btn5tim.Enabled = False
        Me.array = 0

        Try
            If Convert.ToInt32(Me.txtJumsu.Text) > maxjumsu Then Me.txtMaxJumsu.Text = Me.txtJumsu.Text
            Me.txtJumsu.Text = "0"
            For i = 0 To Me.MainPan.Controls.Count - 1
                Me.MainPan.Controls(i).Top = -0
            Next i
        Catch
        End Try
    End Sub

    Private Sub randomtim_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles randomtim.Tick
        Dim r = New Random()
        selectlbl = r.Next(1, 6)
        Select Case selectlbl
            Case 1
                Me.btn1tim.Enabled = True
            Case 2
                Me.btn2tim.Enabled = True
            Case 3
                Me.btn3tim.Enabled = True
            Case 4
                Me.btn4tim.Enabled = True
            Case 5
                Me.btn5tim.Enabled = True
        End Select
    End Sub

    Private Sub btn1tim_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn1tim.Tick
        Dim r = New Random()
        Dim txt = r.Next(0, array)
        If Me.MainPan.Controls(0).Top <= Me.MainPan.Height - (Me.MainPan.Controls(0)).Height Then
            Me.MainPan.Controls(0).Top += 20
        Else
            Me.MainPan.Controls(0).Top = -0
            Me.MainPan.Controls(0).Text = word(txt)
            If (lblLife.Width <> 0) Then lblLife.Width -= 20
        End If
    End Sub

    Private Sub btn2tim_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn2tim.Tick
        Dim r = New Random()
        Dim txt = r.Next(0, array)
        If Me.MainPan.Controls(1).Top <= Me.MainPan.Height - Me.MainPan.Controls(1).Height Then
            Me.MainPan.Controls(1).Top += 20
        Else

            Me.MainPan.Controls(1).Top = -0
            Me.MainPan.Controls(1).Text = word(txt)
            If (lblLife.Width <> 0) Then lblLife.Width -= 20
        End If
    End Sub

    Private Sub btn3tim_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn3tim.Tick
        Dim r = New Random()
        Dim txt = r.Next(0, array)
        If Me.MainPan.Controls(2).Top <= Me.MainPan.Height - Me.MainPan.Controls(2).Height Then
            Me.MainPan.Controls(2).Top += 20
        Else

            Me.MainPan.Controls(2).Top = -0
            Me.MainPan.Controls(2).Text = word(txt)
            If (lblLife.Width <> 0) Then lblLife.Width -= 20
        End If
    End Sub

    Private Sub btn4tim_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn4tim.Tick
        Dim r = New Random()
        Dim txt = r.Next(0, array)
        If Me.MainPan.Controls(3).Top <= Me.MainPan.Height - Me.MainPan.Controls(3).Height Then
            Me.MainPan.Controls(3).Top += 20
        Else

            Me.MainPan.Controls(3).Top = -0
            Me.MainPan.Controls(3).Text = word(txt)
            If (lblLife.Width <> 0) Then lblLife.Width -= 20
        End If
    End Sub

    Private Sub btn5tim_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn5tim.Tick
        Dim r = New Random()
        Dim txt = r.Next(0, array)
        If Me.MainPan.Controls(4).Top <= Me.MainPan.Height - Me.MainPan.Controls(4).Height Then
            Me.MainPan.Controls(4).Top += 20
        Else

            Me.MainPan.Controls(4).Top = -0
            Me.MainPan.Controls(4).Text = word(txt)
            If lblLife.Width <> 0 Then lblLife.Width -= 20
        End If
    End Sub

    Private Sub lblLife_SizeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblLife.SizeChanged
        If lblLife.Width = 0 Then
            randomtim.Enabled = False
            btn1tim.Enabled = False
            btn2tim.Enabled = False
            btn3tim.Enabled = False
            btn4tim.Enabled = False
            btn5tim.Enabled = False
            If Convert.ToInt32(Me.txtJumsu.Text) > maxjumsu Then Me.txtMaxJumsu.Text = Me.txtJumsu.Text
            For i = 0 To Me.MainPan.Controls.Count - 1
                Me.MainPan.Controls(i).Top = 0
            Next
            Me.txtJumsu.Text = "0"
            MessageBox.Show("게임 아웃!!", "알림", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Me.btnStart.Focus()
        End If
    End Sub

    Private Sub txtJumsu_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtJumsu.TextChanged
        If Convert.ToInt32(Me.txtJumsu.Text) <> 0 Then
            If Convert.ToInt32(Me.txtJumsu.Text) Mod 100 = 0 Then
                lblGrade.Text = Convert.ToString(Convert.ToInt32(lblGrade.Text) + 1)
                For i = 0 To Me.MainPan.Controls.Count - 1
                    Me.MainPan.Controls(i).Top = -0
                Next i
                btn1tim.Enabled = False
                btn2tim.Enabled = False
                btn3tim.Enabled = False
                btn4tim.Enabled = False
                btn5tim.Enabled = False
                Me.txtInsert.Text = ""
                Me.txtInsert.Focus()
            End If
        End If
    End Sub

    Private Sub lblGrade_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblGrade.TextChanged
        Select Case Convert.ToInt32(lblGrade.Text)
            Case 1
                btn1tim.Interval = 1000
                btn2tim.Interval = 1000
                btn3tim.Interval = 1000
                btn4tim.Interval = 1000
                btn5tim.Interval = 1000
            Case 2
                btn1tim.Interval = 900
                btn2tim.Interval = 900
                btn3tim.Interval = 900
                btn4tim.Interval = 900
                btn5tim.Interval = 900
            Case 3
                btn1tim.Interval = 800
                btn2tim.Interval = 800
                btn3tim.Interval = 800
                btn4tim.Interval = 800
                btn5tim.Interval = 800
            Case 4
                btn1tim.Interval = 700
                btn2tim.Interval = 700
                btn3tim.Interval = 700
                btn4tim.Interval = 700
                btn5tim.Interval = 700
            Case 5
                btn1tim.Interval = 600
                btn2tim.Interval = 600
                btn3tim.Interval = 600
                btn4tim.Interval = 600
                btn5tim.Interval = 600
            Case 6
                btn1tim.Interval = 500
                btn2tim.Interval = 500
                btn3tim.Interval = 500
                btn4tim.Interval = 500
                btn5tim.Interval = 500
            Case 7
                btn1tim.Interval = 400
                btn2tim.Interval = 400
                btn3tim.Interval = 400
                btn4tim.Interval = 400
                btn5tim.Interval = 400
            Case 8
                btn1tim.Interval = 300
                btn2tim.Interval = 300
                btn3tim.Interval = 300
                btn4tim.Interval = 300
                btn5tim.Interval = 300
            Case 9
                btn1tim.Interval = 200
                btn2tim.Interval = 200
                btn3tim.Interval = 200
                btn4tim.Interval = 200
                btn5tim.Interval = 200
            Case 10
                btn1tim.Interval = 110
                btn2tim.Interval = 110
                btn3tim.Interval = 110
                btn4tim.Interval = 110
                btn5tim.Interval = 110
            Case Else
                btn1tim.Interval = 50
                btn2tim.Interval = 50
                btn3tim.Interval = 50
                btn4tim.Interval = 50
                btn5tim.Interval = 50
        End Select
    End Sub

    Private Sub 종료ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 종료ToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub txtInsert_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtInsert.KeyDown
        Dim r = New Random()
        Dim randomtxt
        If e.KeyCode = Keys.Enter Then
            For i = 0 To Me.MainPan.Controls.Count - 1
                If Me.txtInsert.Text = Me.MainPan.Controls(i).Text Then
                    randomtxt = r.Next(0, array)
                    Me.MainPan.Controls(i).Text = Me.word(randomtxt)
                    jumsu += 10
                    Me.MainPan.Controls(i).Top = -0
                    Me.txtJumsu.Text = Convert.ToString(jumsu)
                End If
            Next i
            Me.txtInsert.Text = ""
        End If
    End Sub

    Private Sub timRanUp_Tick(sender As Object, e As EventArgs) Handles timRanUp.Tick
        If Me.chbUpgrade.Checked = True And Me.MainPan.Controls(0).Text <> "" And Me.MainPan.Controls(1).Text <> "" _
            And Me.MainPan.Controls(2).Text <> "" And Me.MainPan.Controls(3).Text <> "" And Me.MainPan.Controls(4).Text <> "" Then
            Dim r = New Random()
            Dim btnSelect = r.Next(1, 6)
            Dim txt = r.Next(0, array)
            Select Case btnSelect
                Case 1
                    Me.MainPan.Controls(0).Text = word(txt)
                Case 2
                    Me.MainPan.Controls(1).Text = word(txt)
                Case 3
                    Me.MainPan.Controls(2).Text = word(txt)
                Case 4
                    Me.MainPan.Controls(3).Text = word(txt)
                Case 5
                    Me.MainPan.Controls(4).Text = word(txt)
            End Select
        End If
    End Sub

    Private Sub chbUpgrade_CheckedChanged(sender As Object, e As EventArgs) Handles chbUpgrade.CheckedChanged
        If Me.chbUpgrade.Checked = True Then
            Me.timRanUp.Enabled = True
        Else
            Me.timRanUp.Enabled = False
        End If
    End Sub
End Class
