﻿Imports System.IO
Public Class Form2
    Public ReadOnly Property ReturnStep() As String
        Get
            Return Me.cbGrade.Text
        End Get
    End Property
    Public ReadOnly Property ReturnKind() As String
        Get
            Return Me.cbKind.Text
        End Get
    End Property

    Private Sub Form2_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lvWordAdd("한글")
    End Sub

    Private Sub lvWordAdd(ByVal kind As String)
        Me.lvWord.Items.Clear()
        Dim f = New FileInfo("setup.txt")
        If f.Exists = True Then
            Dim sr = File.OpenText("setup.txt")
            While True
                Dim str = sr.ReadLine()
                If str Is Nothing Then Exit While
                Dim a_str = str.Split("&")
                If kind = "한글" Then
                    If str.Split("&")(0) = "1" Then Me.lvWord.Items.Add(str.Split("&")(1))
                Else
                    If str.Split("&")(0) = "2" Then Me.lvWord.Items.Add(str.Split("&")(1))
                End If
            End While
            sr.Close()
        End If
    End Sub

    Private Sub btnInsert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInsert.Click
        If Me.txtInsert.Text = "" Then
            Me.txtInsert.Focus()
        Else
            Dim str = Me.txtInsert.Text
            Dim dlr = MessageBox.Show("[" + str + "]을 저장합니다..", "저장하기", MessageBoxButtons.YesNo, MessageBoxIcon.Information)
            Select Case dlr
                Case DialogResult.Yes
                    Dim f = New FileInfo("setup.txt")
                    If f.Exists = True Then
                        Dim sw = New StreamWriter(New FileStream("setup.txt", FileMode.Append))
                        Dim s = ""
                        If Me.cbKind.Text = "영어" Then
                            s = "2" + "&" + Me.txtInsert.Text
                        Else
                            s = "1" + "&" + Me.txtInsert.Text
                        End If
                        sw.WriteLine(s)
                        sw.Close()
                        Me.lvWord.Items.Add(Me.txtInsert.Text)
                    Else
                        Dim sw = File.CreateText("setup.txt")
                        Dim s = ""
                        If Me.cbKind.Text = "영어" Then
                            s = "2" + "&" + Me.txtInsert.Text
                        Else
                            s = "1" + "&" + Me.txtInsert.Text
                        End If
                        sw.WriteLine(s)
                        sw.Close()
                        Me.lvWord.Items.Add(Me.txtInsert.Text)
                    End If
                Case DialogResult.No
            End Select
            Me.txtInsert.Text = ""
            Me.txtInsert.Focus()
        End If
    End Sub

    Private Sub cbKind_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbKind.SelectedIndexChanged
        If Me.cbKind.SelectedItem.ToString() = "한글" Then
            lvWordAdd("한글")
        Else
            lvWordAdd("영어")
        End If
    End Sub

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        DialogResult = DialogResult.OK
    End Sub
End Class