﻿Imports System.Threading '스레드 개체 사용
Imports PlayWav 'Wav 재생을 위한 DllImport 사용

Public Class Form1

    Private WavPlayThread As Thread '스레드 개체 생성
    Private FilePath = "" 'Wav 파일 경로 저장

    Private Sub btnPath_Click(sender As Object, e As EventArgs) Handles btnPath.Click
        If Me.ofdFile.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.txtPath.Text = Me.ofdFile.FileName
            Me.FilePath = Me.ofdFile.FileName
        End If
    End Sub

    Private Sub SoundPlay()
        Player.PlaySoundStart(Me.ofdFile.FileName, New System.IntPtr(), Player.PlaySoundFlags.SND_SYNC)
        WavPlayThread.Abort()
    End Sub

    Private Sub btnPlay_Click(sender As Object, e As EventArgs) Handles btnPlay.Click
        If Me.txtPath.Text <> "" Then
            WavPlayThread = New Thread(AddressOf SoundPlay)
            WavPlayThread.Start()
        End If
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If Not WavPlayThread Is Nothing Then
            WavPlayThread.Abort()
            Application.ExitThread()
        End If
    End Sub
End Class