﻿Imports MySql.Data.MySqlClient

Public Class Form1
    Dim StrSQL As String = "Data Source=localhost;Database=mook;User Id=root;Password=p12345!@;SslMode=none;CharSet=utf8;port=3307" '데이터베이스 연결 문자열
    Dim Data_Num As String '선택된 lvList 컨트롤 행의 값 저장

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        lvList_MySqlClient_View()
    End Sub

    Private Sub lvList_MySqlClient_View()
        Me.lvList.Items.Clear()
        Dim Conn = New MySqlConnection(StrSQL)
        Conn.Open()

        Dim Comm = New MySqlCommand("Select * From carinfo", Conn)
        Dim myRead = Comm.ExecuteReader()
        While myRead.Read()
            Dim strArray = New String() {myRead("id").ToString(),
                    myRead("c_name").ToString(), myRead("c_year").ToString(),
                    myRead("c_price").ToString(), myRead("c_door").ToString()}
            Dim lvt = New ListViewItem(strArray)
            Me.lvList.Items.Add(lvt)
        End While
        myRead.Close()
            Conn.Close()
        End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        If Me.txtName.Text <> "" And Me.txtYear.Text <> "" And Me.txtPrice.Text <> "" And Me.txtDoor.Text <> "" Then

            Dim Conn = New MySqlConnection(StrSQL)
            Conn.Open()
            Dim Sql As String = "insert into carinfo(c_name, c_year, c_price, c_door) values('"
            Sql += Me.txtName.Text & "'," & Me.txtYear.Text & ",'" &
                    Me.txtPrice.Text & "'," & Convert.ToInt32(Me.txtDoor.Text) & ")"
            Dim Comm = New MySqlCommand(Sql, Conn)
            Dim i As Integer = Comm.ExecuteNonQuery()
            Conn.Close()
            If i = 1 Then
                MessageBox.Show("정상적으로 데이터가 저장되었습니다.", "알림",
                        MessageBoxButtons.OK, MessageBoxIcon.Information)
                lvList_MySqlClient_View()
                Control_Clear()
            Else
                MessageBox.Show("정상적으로 데이터가 저장되지 않았습니다.", "에러",
                        MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub Control_Clear()
        Me.txtName.Clear()
        Me.txtYear.Clear()
        Me.txtPrice.Clear()
        Me.txtDoor.Clear()
    End Sub

    Private Sub lvList_Click(sender As Object, e As EventArgs) Handles lvList.Click
        If Me.lvList.SelectedItems.Count > 0 Then
            Me.txtName.Text = Me.lvList.SelectedItems(0).SubItems(1).Text
            Me.txtYear.Text = Me.lvList.SelectedItems(0).SubItems(2).Text
            Me.txtPrice.Text = Me.lvList.SelectedItems(0).SubItems(3).Text
            Me.txtDoor.Text = Me.lvList.SelectedItems(0).SubItems(4).Text
            Data_Num = Me.lvList.SelectedItems(0).SubItems(0).Text
        End If
    End Sub

    Private Sub btnModify_Click(sender As Object, e As EventArgs) Handles btnModify.Click
        If Me.txtName.Text <> "" And Me.txtYear.Text <> "" And Me.txtPrice.Text <> "" And Me.txtDoor.Text <> "" Then
            Try
                Dim Conn = New MySqlConnection(StrSQL)
                Conn.Open()

                Dim MySqlAdapter = New MySqlDataAdapter("select * from carinfo", Conn)

                Dim ds = New DataSet()
                MySqlAdapter.Fill(ds, "dsTable")
                Dim dt = ds.Tables("dsTable").Select("id =" & Convert.ToInt32(Data_Num), Nothing, DataViewRowState.CurrentRows)

                Dim drTemp As DataRow
                drTemp = dt(0)
                drTemp("c_name") = Me.txtName.Text
                drTemp("c_year") = Me.txtYear.Text
                drTemp("c_price") = Me.txtPrice.Text
                drTemp("c_door") = Me.txtDoor.Text

                Dim cmdBuild = New MySqlCommandBuilder(MySqlAdapter)
                MySqlAdapter.UpdateCommand = cmdBuild.GetUpdateCommand()
                MySqlAdapter.Update(ds, "dsTable")
                cmdBuild.Dispose()

                MessageBox.Show("정상적으로 데이터가 수정되었습니다.", "알림",
                        MessageBoxButtons.OK, MessageBoxIcon.Information)
                lvList_MySqlClient_View()
                Control_Clear()
            Catch ex As Exception
                MessageBox.Show("정상적으로 데이터가 수정되지 않았습니다.", "에러",
                                MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub

    Private Sub btnSearch_Click(sender As Object, e As EventArgs) Handles btnSearch.Click
        Me.lvList.Items.Clear()
        Dim Conn = New MySqlConnection(StrSQL)
        Conn.Open()

        Dim Comm = New MySqlCommand("Select * From carinfo where c_name = '" & Me.txtName.Text & "' or c_year = '" _
                & Me.txtYear.Text & "' or c_price = '" & Me.txtPrice.Text & "' or c_door = " _
                & If(Convert.ToInt32(Me.txtDoor.Text = ""), 0, Convert.ToInt32(Me.txtDoor.Text)) & "", Conn)
        Dim myRead = Comm.ExecuteReader()
        While (myRead.Read())
            Dim strArray = New String() {myRead("id").ToString(),
                    myRead("c_name").ToString(), myRead("c_year").ToString(),
                    myRead("c_price").ToString(), myRead("c_door").ToString()}
            Dim lvt = New ListViewItem(strArray)
            Me.lvList.Items.Add(lvt)
        End While
        myRead.Close()
        Conn.Close()
    End Sub

    Private Sub 삭제ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 삭제ToolStripMenuItem.Click
        If Me.lvList.SelectedItems.Count > 0 Then
            Dim dlr As DialogResult = MessageBox.Show("데이터를 삭제할까요?", "알림", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
            If dlr = DialogResult.Yes Then
                Dim Conn = New MySqlConnection(StrSQL)
                Conn.Open()
                Dim Sql As String = "delete from carinfo where id = " & Convert.ToInt32(Me.lvList.SelectedItems(0).SubItems(0).Text) & ""
                Dim Comm = New MySqlCommand(Sql, Conn)
                Dim i As Integer = Comm.ExecuteNonQuery()
                If i = 1 Then
                    MessageBox.Show("데이터가 정상적으로 삭제되었습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Else
                    MessageBox.Show("데이터를 삭제하지 못하였습니다..", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
                Control_Clear()
                lvList_MySqlClient_View()
            End If
        Else
            MessageBox.Show("삭제할 행을 선택하세요.", "알림",
                        MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End If
    End Sub
End Class
