﻿Imports System.Threading
Imports System.IO
Public Class Form2
    Public Property FileName As String
    Public Property FileSrc As String
    Public Property FileDest As String
    Delegate Sub SetProgCallBack(ByVal vy As Integer) '진행률 Progress
    Dim OnSetProg As SetProgCallBack = Nothing
    Delegate Sub SetLabelCallBack(ByVal str As String) '진행률 텍스트
    Dim OnLabel As SetLabelCallBack = Nothing
    Dim t1 As Thread = Nothing '스레드 개체 선언
    Dim bts(4095) As Byte '파일 분할 저장
    Dim fsSrc As FileStream = Nothing '소스 파일 스트림 개채 선언
    Dim fsDest As FileStream = Nothing '목적지 파일 스트림 개체 선언

    Private Sub Form2_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnSetProg = New SetProgCallBack(AddressOf SetProgBar)
        OnLabel = New SetLabelCallBack(AddressOf SetLabel)

        fsSrc = New FileStream(FileSrc, FileMode.Open, FileAccess.Read)
        fsDest = New FileStream(FileDest, FileMode.Create, FileAccess.Write)

        Me.pgbCopy.Maximum = 100
        Me.lblFileName.Text = "파 일 : " & FileName
        t1 = New Thread(New ThreadStart(AddressOf FileCopy))
        t1.Start()
    End Sub

    Private Sub SetProgBar(ByVal vv As Integer)
        Me.pgbCopy.Value = vv
    End Sub

    Private Sub SetLabel(ByVal str As String)
        Me.lblCopy.Text = str
    End Sub

    Private Sub FileCopy()
        Dim vv As Integer = 1
        Dim cnt As Integer = 0
        Dim kk As Integer = CInt(fsSrc.Length / 4096)
        Dim ss As Integer = CInt(fsSrc.Length Mod 4096)

        While True
            Thread.Sleep(10)
            Dim tmpCnt As Integer = 0
            If ss > 0 Then tmpCnt = 1
            If (kk + tmpCnt) = cnt Then Exit While

            bts = New Byte(4095) {}

            If cnt < kk Then
                fsSrc.Seek(4096 * cnt, SeekOrigin.Begin)
                fsSrc.Read(bts, 0, 4096)

                fsDest.Seek(4096 * cnt, SeekOrigin.Begin)
                fsDest.Write(bts, 0, 4096)
            Else
                fsSrc.Seek(4096 * cnt, SeekOrigin.Begin)
                fsSrc.Read(bts, 0, ss)

                fsDest.Seek(4096 * cnt, SeekOrigin.Begin)
                fsDest.Write(bts, 0, ss)
            End If

            cnt += 1

            vv = CInt(fsDest.Length * 100 / fsSrc.Length)
            If vv > 100 Then
                Invoke(OnSetProg, 100)
            Else
                Invoke(OnSetProg, vv)
            End If
            Invoke(OnLabel, "복사 : " + vv.ToString() + "%")
        End While
        fsDest.Close()
        fsSrc.Close()
        DialogResult = DialogResult.OK
    End Sub

    Private Sub Form2_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If t1 IsNot Nothing Then t1.Abort()
    End Sub
End Class