﻿Imports System.Threading

Public Class Form1

    Dim SumThre As Thread = Nothing
    Private Delegate Sub OnResultDelegate(ByVal num As String, ByVal f As Boolean)
    Private OnResult As OnResultDelegate = Nothing

    Private Sub btnSum_Click(sender As Object, e As EventArgs) Handles btnSum.Click
        SumThre = New Thread(New ParameterizedThreadStart(AddressOf SumThreRun))
        SumThre.Start(Me.txtNum.Text)
    End Sub

    Private Sub SumThreRun(n As Object)
        Dim sum As Long = 0
        Dim k = Convert.ToInt64(n)
        For i As Long = 1 To k
            Thread.Sleep(1)
            sum += i
            Invoke(OnResult, sum.ToString(), True)
        Next i
        Invoke(OnResult, sum.ToString(), False)
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnResult = New OnResultDelegate(AddressOf OnResultRun)
    End Sub

    Private Sub OnResultRun(ByVal num As String, ByVal f As Boolean)
        If f Then
            Me.lblResult.Text = String.Format("계산중 : {0}", num.ToString())
        Else
            Me.lblResult.Text = String.Format("계산 결과 : {0}", num.ToString())
        End If
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If SumThre IsNot Nothing Then
            SumThre.Abort()
        End If
    End Sub
End Class