﻿Imports System.IO
Imports System.IO.Compression

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If Not Directory.Exists("temp") Then
            Directory.CreateDirectory("temp")
        End If
    End Sub

    Private Sub btnPath_Click(sender As Object, e As EventArgs) Handles btnPath.Click
        If Me.ofdFile.ShowDialog() = DialogResult.OK Then
            For Each p As String In Me.ofdFile.FileNames
                Dim fi As FileInfo = New FileInfo(p)
                Me.lvList.Items.Add(New ListViewItem(New String() {fi.FullName, fi.Length.ToString()}))
            Next
        End If
    End Sub

    Private Sub btnComp_Click(sender As Object, e As EventArgs) Handles btnComp.Click
        If Me.lvList.Items.Count > 0 Then
            If Me.sfdFile.ShowDialog() = DialogResult.OK Then
                For i As Integer = 0 To Me.lvList.Items.Count - 1
                    Dim fi As FileInfo = New FileInfo(Me.lvList.Items(i).SubItems(0).Text)
                    fi.CopyTo(Application.StartupPath & "\temp\" & fi.Name)
                Next
                ZipFile.CreateFromDirectory(Application.StartupPath & "\temp\", Me.sfdFile.FileName, CompressionLevel.Fastest, False)
                Dim di As DirectoryInfo = New DirectoryInfo(Application.StartupPath & "\temp\")
                For Each ffi As FileInfo In di.GetFiles()
                    ffi.Delete()
                Next
                MessageBox.Show("압축을 완료하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.lvList.Items.Clear()
            Else
                MessageBox.Show("압축 파일 이름을 입력하세요.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Else
            MessageBox.Show("압축할 대상 파일이 없습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub btnDeComp_Click(sender As Object, e As EventArgs) Handles btnDeComp.Click
        If Me.ofdFile.ShowDialog() = DialogResult.OK Then
            If Me.fbdFolder.ShowDialog() = DialogResult.OK Then
                ZipFile.ExtractToDirectory(Me.ofdFile.FileName, Me.fbdFolder.SelectedPath)
                MessageBox.Show("압축 해제를 완료하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Process.Start(Me.fbdFolder.SelectedPath)
            End If
        Else
            MessageBox.Show("압축을 해제할 경로를 입력하세요.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub
End Class
