﻿Imports System.Runtime.InteropServices
Imports Microsoft.Win32

Public Class Form1

    Dim registry As RegistryKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", True) '프록시 정보 레지스트리 저장

    <DllImport("wininet.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Shared Function InternetSetOption(hInternet As IntPtr, dwOption As Integer, lpBuffer As IntPtr, dwBufferLength As Integer) As Boolean
    End Function

    Dim ProxyIP As String = String.Empty '프록시 서버 아이피
    Dim ProxyPort As String = String.Empty '프록시 포트

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.tlscbOn.Text = "OFF"
    End Sub

    Private Sub tlsbtnGo_Click(sender As Object, e As EventArgs) Handles tlsbtnGo.Click
        Me.webBrowser.Navigate(Me.tlstxtUrl.Text)
    End Sub

    Private Sub tlscbOn_SelectedIndexChanged(sender As Object, e As EventArgs) Handles tlscbOn.SelectedIndexChanged
        If Me.tlscbOn.Text = "ON" Then
            Dim frm2 As Form2 = New Form2()
            If frm2.ShowDialog() = DialogResult.OK Then
                ProxyIP = frm2.ProxyIP
                ProxyPort = frm2.ProxyPort
                frm2.Close()
                registry.SetValue("ProxyServer", ProxyIP & ":" & ProxyPort)
                registry.SetValue("ProxyEnable", 1)
                InternetSetOption(IntPtr.Zero, 39, IntPtr.Zero, 0)
                InternetSetOption(IntPtr.Zero, 37, IntPtr.Zero, 0)
            End If
        Else
            registry.SetValue("ProxyServer", "")
            registry.SetValue("ProxyEnable", 0)
            InternetSetOption(IntPtr.Zero, 39, IntPtr.Zero, 0)
            InternetSetOption(IntPtr.Zero, 37, IntPtr.Zero, 0)
        End If
    End Sub
End Class
