﻿Imports System.Data.OleDb 'OleDbConnection, OleDbCommand 클래스 등 사용

Public Class Form1
    Private StrSQL As String = "Provider=Microsoft.ACE.OLEDB.16.0;Data Source=humaninfo.accdb;Mode=ReadWrite" '데이터베이스 연결 문자열
    Private num As Integer '데이터베이스 인덱스
    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If (Control_Check() = True) Then
            Dim Conn = New OleDbConnection(StrSQL)
            Conn.Open()
            Dim Sql = "INSERT INTO t_info(m_name, m_age, m_phone, m_job)" _
            & "values('" & Me.txtName.Text & "'," & Convert.ToInt32(Me.txtAge.Text) & ",'" & Me.txtPhone.Text & "','" & Me.txtJob.Text & "')"
            Dim Comm = New OleDbCommand(Sql, Conn)
            Dim i = Comm.ExecuteNonQuery()
            Conn.Close()
            If (i = 1) Then
                MessageBox.Show("정상적으로 데이터가 저장되었습니다.", "알림",
                                MessageBoxButtons.OK, MessageBoxIcon.Information)
                lvList_OleDb_View()
                Control_Empty()
            Else
                MessageBox.Show("정상적으로 데이터가 저장되지 않았습니다.", "에러",
                                MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub
    Private Function Control_Check() As Boolean
        If (Me.txtName.Text = "") Then
            MessageBox.Show("이름을 입력하세요!!", "에러", MessageBoxButtons.OK,
                            MessageBoxIcon.Error)
            Me.txtName.Focus()
            Return False
        ElseIf (Me.txtAge.Text = "") Then
            MessageBox.Show("나이를 입력하세요!!", "에러", MessageBoxButtons.OK,
                            MessageBoxIcon.Error)
            Me.txtAge.Focus()
            Return False
        ElseIf (Me.txtPhone.Text = "") Then
            MessageBox.Show("전화번호를 입력하세요!!", "에러", MessageBoxButtons.OK,
                            MessageBoxIcon.Error)
            Me.txtPhone.Focus()
            Return False
        Else
            Return True
        End If
    End Function
    Private Sub Control_Empty()
        Me.txtName.Clear()
        Me.txtAge.Clear()
        Me.txtPhone.Clear()
        Me.txtJob.Clear()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lvList_OleDb_View()
    End Sub
    Private Sub lvList_OleDb_View()
        Me.lvList.Items.Clear() 'lvList 컨트롤의 Items 속성 클리어
        Dim Conn = New OleDbConnection(StrSQL)
        Conn.Open()

        Dim Comm = New OleDbCommand("SELECT * FROM t_info", Conn)
        Dim myRead = Comm.ExecuteReader()
        While (myRead.Read())
            Dim strArray = New String() {myRead(0).ToString(),
                myRead(1).ToString(), myRead(2).ToString(), myRead(3).ToString(), myRead(4).ToString()}
            Dim lvt = New ListViewItem(strArray)
            Me.lvList.Items.Add(lvt)
        End While
        myRead.Close()
        Conn.Close()
    End Sub

    Private Sub btnModify_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnModify.Click
        If (Control_Check() = True) Then
            Dim Conn = New OleDbConnection(StrSQL)
            Conn.Open()
            Dim Sql = "UPDATE t_info SET m_name ='" & Me.txtName.Text & "', m_age=" & Convert.ToInt32(Me.txtAge.Text)
            Sql += ", m_phone='" & Me.txtPhone.Text & "', m_job= '" & Me.txtJob.Text & "' WHERE m_id =" & num & ""
            Dim Comm = New OleDbCommand(Sql, Conn)
            Dim i = Comm.ExecuteNonQuery()
            Conn.Close()
            If (i = 1) Then
                MessageBox.Show("정상적으로 데이터가 수정되었습니다.", "알림",
                                MessageBoxButtons.OK, MessageBoxIcon.Information)
                lvList_DataSet_View()
                Control_Empty()
            Else
                MessageBox.Show("정상적으로 데이터가 수정되지 않았습니다.", "에러",
                                MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub lvList_DataSet_View()
        Me.lvList.Items.Clear()
        Dim Conn As OleDbConnection = New OleDbConnection(StrSQL)
        Conn.Open()

        Dim OleAdapter As OleDbDataAdapter = New OleDbDataAdapter("SELECT * FROM t_info", Conn)

        Dim ds As DataSet = New DataSet()
        Dim dt As DataTable = ds.Tables.Add("dsTable")
        OleAdapter.Fill(ds, "dsTable")

        Dim query As IEnumerable(Of DataRow) =
            From HumanInfo In dt.AsEnumerable() Select HumanInfo

        For Each HumData As DataRow In query
            Dim strArray As String() = New String() {HumData.Field(Of Integer)("m_id").ToString(), HumData.Field(Of String)("m_name"),
                                HumData.Field(Of Integer)("m_age").ToString(), HumData.Field(Of String)("m_phone"), HumData.Field(Of String)("m_job")}
            Me.lvList.Items.Add(New ListViewItem(strArray))
        Next
        Conn.Close()
    End Sub

    Private Sub btnDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDel.Click
        Dim dlr = MessageBox.Show("삭제할까요?", "알림",
                                  MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        Select Case (dlr)
            Case DialogResult.Yes
                Dim Conn = New OleDbConnection(StrSQL)
                Conn.Open()
                Dim Sql = "DELETE FROM t_info WHERE m_id =" & num & ""
                Dim Comm = New OleDbCommand(Sql, Conn)
                Dim i = Comm.ExecuteNonQuery()
                Conn.Close()
                If (i = 1) Then
                    MessageBox.Show("정상적으로 데이터가 삭제되었습니다.", "알림",
                                    MessageBoxButtons.OK, MessageBoxIcon.Information)
                    lvList_DataSetRamda_View()
                    Control_Empty()
                Else
                    MessageBox.Show("정상적으로 데이터가 삭제되지 않았습니다.",
                                    "에러", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Case DialogResult.No
        End Select
    End Sub

    Private Sub lvList_DataSetRamda_View()
        Me.lvList.Items.Clear()
        Dim Conn As OleDbConnection = New OleDbConnection(StrSQL)
        Conn.Open()

        Dim OleAdapter As OleDbDataAdapter = New OleDbDataAdapter("SELECT * FROM t_info", Conn)

        Dim ds As DataSet = New DataSet()
        Dim dt As DataTable = ds.Tables.Add("dsTable")
        OleAdapter.Fill(ds, "dsTable")

        Dim query As EnumerableRowCollection = dt.AsEnumerable().
                [Select](Function(HumanInfo) New With
                {
                    Key .Id = HumanInfo.Field(Of Integer)("m_id").ToString(),
                    Key .Name = HumanInfo.Field(Of String)("m_name"),
                    Key .Age = HumanInfo.Field(Of Integer)("m_age").ToString(),
                    Key .Phone = HumanInfo.Field(Of String)("m_phone"),
                    Key .Job = HumanInfo.Field(Of String)("m_job")
                })

        For Each HumData In query
            Dim strArray As String() = New String() {HumData.Id, HumData.Name, HumData.Age, HumData.Phone, HumData.Job}
            Me.lvList.Items.Add(New ListViewItem(strArray))
        Next
        Conn.Close()
    End Sub

    Private Sub lvList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvList.Click
        If Me.lvList.SelectedItems.Count > 0 Then
            num = Convert.ToInt32(Me.lvList.SelectedItems(0).SubItems(0).Text)
            Me.txtName.Text = Me.lvList.SelectedItems(0).SubItems(1).Text
            Me.txtAge.Text = Me.lvList.SelectedItems(0).SubItems(2).Text
            Me.txtPhone.Text = Me.lvList.SelectedItems(0).SubItems(3).Text
            Me.txtJob.Text = Me.lvList.SelectedItems(0).SubItems(4).Text
        End If
    End Sub
End Class

