﻿Imports System.IO
Imports System.Net
Imports System.Net.Sockets
Imports System.Threading
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization

Public Class Form1
    Private server As TcpListener 'TCP 리스터 개체 
    Private ip As IPAddress = New IPAddress(0) '서버 아이피
    Private myWrite As StreamWriter '스트림 쓰기

    Private servClient As TcpClient 'TCP 클라이언트 개체
    Private ns As NetworkStream '네트워크 스트림 개체
    Private reader As BinaryReader '바이너리 읽기

    Private thread As Thread = Nothing '파일 수신 스레드

    Private Delegate Sub OnFileDelegate(ByVal d As String, ByVal s As String)
    Private OnFile As OnFileDelegate = Nothing '델리게이트 선언

    Private Sub btnReceive_Click(sender As Object, e As EventArgs) Handles btnReceive.Click
        server = New TcpListener(ip, 63000)
        server.Start()
        thread = New Thread(AddressOf AcceptFile)
        thread.Start()
        Me.tsslblConn.Text = "상태 : 파일 받기 작동"
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnFile = New OnFileDelegate(AddressOf OnFileRun)
        If Not Directory.Exists(Application.StartupPath & "\File") Then
            Directory.CreateDirectory(Application.StartupPath & "\File")
        End If
    End Sub

    Private Sub OnFileRun(ByVal d As String, ByVal s As String)
        Dim Data As String = String.Format("[{0}] : {1}", d, s)
        Me.lbFileList.Items.Add(Data)
    End Sub

    Private Sub AcceptFile()
        While (True)
            Try
                servClient = server.AcceptTcpClient()
                ns = servClient.GetStream()
                myWrite = New StreamWriter(ns)
                reader = New BinaryReader(ns)
                Dim length As Integer = reader.ReadInt32()
                Dim packet As Byte() = reader.ReadBytes(length)
                Dim mypacket As mook_Packet.Packet = BytesToObject(packet)

                Dim fs As FileStream = New FileStream(Application.StartupPath & "\File\" & mypacket.FName, FileMode.Create)
                fs.Write(mypacket.Data, 0, mypacket.Size)
                fs.Close()
                Invoke(OnFile, mypacket.DTime, mypacket.FName)
                myWrite.WriteLine(mypacket.FName)
                myWrite.Flush()
            Catch ex As Exception

            End Try
        End While
    End Sub

    Private Function BytesToObject(ByVal data As Byte()) As mook_Packet.Packet
        Dim MS As MemoryStream = New MemoryStream()
        Dim bf As New BinaryFormatter()
        MS.Write(data, 0, data.Length)
        MS.Seek(0, SeekOrigin.Begin)
        Dim obj As Object = TryCast(bf.Deserialize(MS), Object)
        Return TryCast(obj, mook_Packet.Packet)
    End Function

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If servClient IsNot Nothing Then servClient.Close()
        If server IsNot Nothing Then server.Stop()
        If thread IsNot Nothing Then thread.Abort()
    End Sub
End Class
