﻿Imports System.Net.NetworkInformation
Imports System.Threading
Imports System.IO

Public Class Form1

    Private ipProperties As IPGlobalProperties = IPGlobalProperties.GetIPGlobalProperties()
    Private NetThread As Thread = Nothing 'NetStat 명령 수행 스레드
    Private LocPort, RemoAdd, RemoPort As String '로컬포트, 원격 아이피, 원격 포트
    Private CheckBool As Boolean = True '검색 여부
    Private Delegate Sub OnNetStatDelegate(ByVal a As String, ByVal b As String, ByVal c As String, ByVal d As String, ByVal e As String, ByVal i As Integer, ByVal f As Boolean, ByVal En As Boolean)
    Private OnNetSate As OnNetStatDelegate = Nothing '델리게이트 선언

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnNetSate = New OnNetStatDelegate(AddressOf NetStatView)
        NetThread = New Thread(AddressOf NetView)
        NetThread.Start()
    End Sub

    Private Sub NetStatView(ByVal a As String, ByVal b As String, ByVal c As String, ByVal d As String, ByVal e As String, ByVal i As Integer, ByVal f As Boolean, ByVal En As Boolean)
        If f = True Then
            Me.lvNetState.Items.Add(a)
            Me.lvNetState.Items(i).SubItems.Add(b)
            Me.lvNetState.Items(i).SubItems.Add(c)
            Me.lvNetState.Items(i).SubItems.Add(d)
            Me.lvNetState.Items(i).SubItems.Add(e)
            If b = LocPort Then Me.lvNetState.Items(i).SubItems(0).BackColor = Color.GreenYellow
            If c = RemoAdd Then Me.lvNetState.Items(i).SubItems(0).BackColor = Color.LightPink
            If d = RemoPort Then Me.lvNetState.Items(i).SubItems(0).BackColor = Color.Aqua
        Else
            If En = False Then Me.lvNetState.Items.Clear()
            NCheck()
        End If
    End Sub

    Private Sub btnCheck_Click(sender As Object, e As EventArgs) Handles btnCheck.Click
        Me.LocPort = Me.txtLocPort.Text
        Me.RemoAdd = Me.txtForAdd.Text
        Me.RemoPort = Me.txtForPort.Text
        NCheck()
    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        If Me.sfdFile.ShowDialog() = DialogResult.OK Then
            Dim sw As StreamWriter = New StreamWriter(Me.sfdFile.FileName)
            sw.WriteLine("파일생성 : " & DateTime.Now)
            sw.WriteLine()
            sw.WriteLine("로컬주소" & vbTab & "로컬포트" & vbTab & "외부주소" & vbTab & "외부포트" & vbTab & "상태")

            For i As Integer = 0 To Me.lvNetState.Items.Count - 1 - 1
                sw.WriteLine(Me.lvNetState.Items(i).SubItems(0).Text & vbTab &
                             Me.lvNetState.Items(i).SubItems(1).Text & vbTab &
                             Me.lvNetState.Items(i).SubItems(2).Text & vbTab &
                             Me.lvNetState.Items(i).SubItems(3).Text & vbTab &
                             Me.lvNetState.Items(i).SubItems(4).Text)
            Next

            sw.WriteLine()
            sw.WriteLine("파일생성 종료 : " & DateTime.Now)
            sw.Close()
        End If
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If NetThread IsNot Nothing Then NetThread.Abort()
        Application.ExitThread()
    End Sub

    Private Sub NetView()
        While True
            Me.CheckBool = True
            Invoke(OnNetSate, "", "", "", "", "", 0, False, False)
            Dim tcpConnections As TcpConnectionInformation() = ipProperties.GetActiveTcpConnections()
            Dim i As Integer = 0

            For Each NetInfo As TcpConnectionInformation In tcpConnections
                Invoke(OnNetSate, NetInfo.LocalEndPoint.Address.ToString(),
                       NetInfo.LocalEndPoint.Port.ToString(),
                       NetInfo.RemoteEndPoint.Address.ToString(),
                       NetInfo.RemoteEndPoint.Port.ToString(),
                       NetInfo.State.ToString(), i, True, False)
                i += 1
            Next
            Me.CheckBool = False
            Invoke(OnNetSate, "", "", "", "", "", 0, False, True)
            Thread.Sleep(30000)
        End While
    End Sub

    Private Sub NCheck()
        If CheckBool Then
            Me.txtLocPort.Enabled = False
            Me.txtForPort.Enabled = False
            Me.txtForAdd.Enabled = False
            Me.btnCheck.Enabled = False
            Me.btnSave.Enabled = False
        Else
            Me.txtLocPort.Enabled = True
            Me.txtForPort.Enabled = True
            Me.txtForAdd.Enabled = True
            Me.btnCheck.Enabled = True
            Me.btnSave.Enabled = True
        End If
    End Sub


End Class
