﻿Imports System.Net
Imports System.Net.Sockets
Imports System.IO
Imports System.Threading

Public Class Form1
    Private scanIp As IPAddress = Nothing '스캔 아이피
    Private strFile As String = Nothing '파일 경로
    Private IPAddre As String = "" '아이피 정보
    Private StartNum As Integer = 0 '시작 포트
    Private EndNum As Integer = 0 '마지막 포트

    Private PortScan As Thread = Nothing '포트 스캔 스레드
    Private Delegate Sub OnPortDeletegate(ByVal a As String, ByVal b As String, ByVal f As Boolean)
    Private OnPort As OnPortDeletegate = Nothing '결과 보여주는 델리게이트

    Private Delegate Sub OnProgressDeletegate(ByVal i As Integer)
    Private OnProgress As OnProgressDeletegate = Nothing '진행사항 보여주는 델리게이트

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnPort = New OnPortDeletegate(AddressOf OnPortScan)
        OnProgress = New OnProgressDeletegate(AddressOf OnProStatus)
    End Sub


    Private Sub OnPortScan(ByVal a As String, ByVal b As String, ByVal f As Boolean)
        If f Then
            Me.lvScan.Items.Add(New ListViewItem(New String() {a, b}))
        Else
            Me.btnStart.Enabled = True
            Me.btnFile.Enabled = True
        End If
    End Sub

    Private Sub OnProStatus(ByVal i As Integer)
        Me.pgbScan.Value = i
    End Sub

    Private Sub btnFile_Click(sender As Object, e As EventArgs) Handles btnFile.Click
        If Me.fbdFile.ShowDialog() = DialogResult.OK Then
            strFile = Me.fbdFile.SelectedPath & "\포트스캔(" & Me.txtIp.Text & ").txt"
        End If
    End Sub

    Private Sub btnStart_Click(sender As Object, e As EventArgs) Handles btnStart.Click
        If strFile IsNot Nothing Then
            IPAddre = Me.txtIp.Text
            StartNum = Convert.ToInt32(Me.txtStart.Text)
            EndNum = Convert.ToInt32(Me.txtEnd.Text)
            Me.pgbScan.Minimum = Convert.ToInt32(Me.txtStart.Text)
            Me.pgbScan.Maximum = Convert.ToInt32(Me.txtEnd.Text)
            Me.btnStart.Enabled = False
            Me.btnFile.Enabled = False

            Me.lblFile.Text = "생성파일 : "
            Me.txtPath.Text = strFile

            PortScan = New Thread(AddressOf PortScanner)
            PortScan.Start()
        End If
    End Sub

    Private Sub PortScanner()
        Dim sw As StreamWriter = New StreamWriter(strFile)
        scanIp = IPAddress.Parse(IPAddre)
        sw.WriteLine("************ 스캔 시작 ************ " & DateTime.Now)
        sw.WriteLine()
        For i As Integer = StartNum To EndNum
            Invoke(OnProgress, i)
            Try
                Dim EndPoint As IPEndPoint = New IPEndPoint(scanIp, i)
                Dim sSocket As Socket = New Socket(AddressFamily.InterNetwork,
                        SocketType.Stream, ProtocolType.Tcp)
                sSocket.Connect(EndPoint)
                sw.WriteLine("ScanPort {0} 열려있음", i)
                Invoke(OnPort, i.ToString(), "open", True)
                Continue For
            Catch ex As SocketException
                If ex.SocketErrorCode <> 10061 Then sw.WriteLine("에러 : {0}", ex.Message)
            End Try
            sw.WriteLine("ScanPort {0} 닫혀있음", i)
            Invoke(OnPort, i.ToString(), "close", True)
        Next
        sw.WriteLine()
        sw.WriteLine("************ 스캔 종료 ************ " & DateTime.Now)
        sw.Close()
        Invoke(OnPort, "", "", False)

        MessageBox.Show("포트 스캔을 완료하였습니다.", "알림",
                MessageBoxButtons.OK, MessageBoxIcon.Information)
        Dim myProcess As Process = New Process()
        myProcess.StartInfo.FileName = strFile
        myProcess.Start()
        PortScan.Abort()
    End Sub
End Class
